.586
.model flat,stdcall
option casemap:none
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\Ws2_32.inc   
include \masm32\include\masm32.inc
include	\masm32\include\advapi32.inc

includelib \masm32\lib\Ws2_32.lib   
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\advapi32.lib

include	\masm32\macros\macros.asm
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
OSVINFO STRUCT
	dwOSVersionInfoSize   DWORD      ?
	dwMajorVersion        DWORD      ?
	dwMinorVersion        DWORD      ?
	dwBuildNumber         DWORD      ?
	dwPlatformId          DWORD      ?
	szCSDVersion          BYTE 128 dup (?)
OSVINFO ENDS
;---------------------------------------------
LUIDCUST STRUCT
	usedpart              DWORD      ?
	ignorehigh32bitpart   DWORD      ?
LUIDCUST ENDS
;---------------------------------------------
TOKEN_PRIVS STRUCT
	privilegecount        DWORD      ?
	theluid               LUIDCUST   <>
	attributes            DWORD      ?
TOKEN_PRIVS ENDS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.const
	IDD_DLG1	equ 1000
	
	IDC_BTSync	equ 1001
	IDC_BTHelp	equ 1002

	IDC_EDT1	equ 1003
	IDC_EDT2	equ 1004
	IDC_EDT3	equ 1005
	IDC_EDT4	equ 1006
	IDC_EDT5	equ 1007
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data
	ClassName	db 'DLGCLASS',0
	DlgName		db 'MyDialog',0
	AboutMsg	db '1. Sync:  Synchronizating your PC time with the specified timerserver at any time.',13,10
			db '2. TimeZone[0-23]:  Towards UTC.',13,10
			db '3. If you want to Synchronizate PC time on 23:59:59 at end day of a month, Time maybe Error.',0

	timeformat 	db "HH:mm:ss",0
	dateformat 	db "yyyy-MM-dd",0
	szCaption	db "Sync Time With TimerServer",0

	sbuffer 	db 100 dup (0)
	dbuffer 	db 100 dup (0)
	szTimerServer	db 128 dup(0)	; timeserver addr
	szPort		db 6 dup(0)	; timeserver port
	hTimeZone 	dd 0
	szTestBuf	db 128 dup(0)	
	format 		db "%04u-%02u-%02u %02u:%02u:%02u %03u",0
	
	Stm		SYSTEMTIME<>
	time		SYSTEMTIME<>
	deltaT1		dd 0
	deltaT2		dd 0
	t1		dd 0	;start reading
	t2		dd 0	;finished reading
	t3		dd 0	;start writing
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data?
	hInstance	dd ?
	hWnd		dd ?
	hIcon		dd ?

	ThreadID	DWORD ?
	hSocket		SOCKET ?
	wsd		WSADATA<?>  
	TServerAddr	sockaddr_in<?>
	Timebuf		db 128 dup(?)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.code
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
IsWinNt proc
	LOCAL vi:OSVINFO		    ; Version Info Struct
	LOCAL pvi:DWORD			    ; Pointer To vi

	lea eax, vi                         ; vi's address into eax
	mov ecx, SizeOf vi                  ; sizeof vi struct into ecx
	mov (OSVINFO PTR [eax]).dwOSVersionInfoSize, ecx    ; copy size to element
	mov pvi, eax                        ; ptr to vi into pvi
	invoke GetVersionEx,pvi             ; get version API call
	cmp eax, 0                          ; See if we got an error
	je  IsWinNtError
    
	mov eax, pvi                        ; address back into eax
	mov ecx, (OSVINFO PTR [eax]).dwPlatformId  ; Platform ID into ecx
	cmp ecx, VER_PLATFORM_WIN32_NT      ; see if its an NT platform
	je  IsWinNtTrue

	mov eax, 0                          ; Return a Zero since its NOT NT
	ret
    
IsWinNtTrue:
	mov eax, 1                          ; Return 1 since it IS NT
	ret

IsWinNtError:
	mov eax, 2                          ; Return 2 indicating an Error
    
	ret

IsWinNt endp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
AdjustToken proc prlgValue:dword
	LOCAL hdlProcessHandle:DWORD
	LOCAL hdlTokenHandle:DWORD
	LOCAL tmpLuid:LUIDCUST
	LOCAL tkp:TOKEN_PRIVS
	LOCAL tkpNewButIgnored:TOKEN_PRIVS
	LOCAL lBufferNeeded:DWORD
	LOCAL tBuff[32]:BYTE
	LOCAL ptBuff:DWORD

	invoke IsWinNt                 ; see if we're on an NT platform
	cmp eax, 1                     ; a return of 1 means NT platform.
	jne AdjTokDone

	invoke GetCurrentProcess       ; get the current process handle
	mov hdlProcessHandle,eax       ; save it to hdlProcessHandle

	lea eax, tBuff                 ; address of temp buffer into eax
	mov ptBuff, eax                ; set pointer to temp buffer
	mov BYTE PTR [eax], 0          ; initialize the buffer

	invoke OpenProcessToken,hdlProcessHandle,40,ADDR hdlTokenHandle
	invoke LookupPrivilegeValue,ptBuff,prlgValue,ADDR tmpLuid

	lea eax, tmpLuid               ; address of tmpLuid into eax

	; Contents of tmpLuid into ecx:edx
	mov ecx, (LUIDCUST PTR [eax]).usedpart
	mov edx, (LUIDCUST PTR [eax]).ignorehigh32bitpart
    
	lea eax, tkp                   ; address of tkp into eax
    
	mov (TOKEN_PRIVS PTR [eax]).privilegecount, 1
	mov (TOKEN_PRIVS PTR [eax]).theluid.usedpart, ecx
	mov (TOKEN_PRIVS PTR [eax]).theluid.ignorehigh32bitpart, edx
	mov (TOKEN_PRIVS PTR [eax]).attributes, 2

	invoke AdjustTokenPrivileges,hdlTokenHandle,0,ADDR tkp,SizeOf tkpNewButIgnored,ADDR tkpNewButIgnored,ADDR lBufferNeeded

AdjTokDone:

	ret

AdjustToken endp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
memcpy proc uses edi esi ecx pDest:dword, pSource:dword, sizeDat:dword
	mov     ecx, sizeDat
        mov     esi, pSource
        mov     edi, pDest
        mov     eax, ecx
        shr     ecx, 2
        rep	movsd
        mov     ecx, eax
        and     ecx, 3
        rep	movsb
        ret
memcpy endp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
HandleError proc lpTitle:DWORD 
	LOCAL lpMsgBuffer:LPVOID ;dword
	
	mov cx, SUBLANG_DEFAULT 
	shl ecx, 10 
	
	push NULL                ; we don't need this 
	push 0                   ; min. size of output buffer if we use 
				 ; FORMAT_MESSAGE_ALLOCATE_BUFFER 
	lea  ebx,lpMsgBuffer     ; get address of our buffer 
	push ebx                 ; address of buffer 
	push ecx                 ; our language ID, calculated above 
	call GetLastError	 ; get error number 
	push eax                 ; push return value = error ID 
	push NULL                ; can be used to format a string, we don't need it 
	mov edx, FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM 
	push edx                 ; some flags, check your doc for more 
	call FormatMessage       ; here we go 
	
	; Display error-message 
	invoke MessageBox, NULL, lpMsgBuffer, lpTitle, MB_OK or MB_ICONSTOP 
	; free memory 
	invoke LocalFree, lpMsgBuffer 
	ret
	
HandleError endp 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
GetHostAddr proc 
	
	invoke GetDlgItemText, hWnd, IDC_EDT5, offset szPort, sizeof szPort
	invoke atodw,offset szPort
	invoke htons, eax
	mov    TServerAddr.sin_port, ax
	mov    TServerAddr.sin_family, AF_INET
	
	invoke	GetDlgItemText, hWnd, IDC_EDT4, offset szTimerServer, sizeof szTimerServer
	invoke	inet_addr, offset szTimerServer
	
	.if	(eax != INADDR_NONE) && (eax != 0)
		mov	TServerAddr.sin_addr, eax
		mov	eax,TRUE
	.else	 
		invoke	gethostbyname, offset szTimerServer
		.if	eax != 0
			mov	eax, dword ptr [eax+12]				
			mov	eax, dword ptr [eax]				
			mov	eax, dword ptr [eax]				
			mov	TServerAddr.sin_addr, eax
			mov	eax,TRUE
		.else
			invoke  HandleError,ADDR szCaption
			invoke  PostQuitMessage,NULL
			mov	eax,FALSE
		.endif
	.endif	 

	ret
GetHostAddr endp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ReadTime proc 
	Local text[3]:byte 

	invoke GetDlgItemText, hWnd, IDC_EDT1, ADDR text, sizeof text
	invoke atodw, ADDR text
	.if (eax >=0 )&&( eax < 24 )
		mov hTimeZone,eax
	.else
		invoke MessageBox,hWnd,SADD("TimeZone must be between 0-23."),addr szCaption,MB_OK or MB_ICONINFORMATION
		mov eax,FALSE
		ret
	.endif

	invoke socket, AF_INET, SOCK_STREAM, 0
	mov    hSocket,eax
	invoke GetTickCount
	mov t1,eax
	invoke connect, hSocket, addr TServerAddr, sizeof TServerAddr
	.if eax != SOCKET_ERROR                                                                           
		invoke recv, hSocket,offset Timebuf,sizeof Timebuf, NULL
		invoke GetTickCount
		mov t2,eax
		invoke closesocket,hSocket
		mov eax,TRUE
	.else
		invoke HandleError,ADDR szCaption
		mov eax,FALSE
	.endif                        		          		          

	ret
ReadTime endp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
SetTime PROC USES esi ebx TimeAddr:DWORD
	Local @Year,@Mon,@Dat,@Hour,@Min,@Sec,@Mss:dword
	Local buf1[3]:byte
	local buf2[3]:byte
	Local buf3[3]:byte
	local buf4[3]:byte
	Local buf5[3]:byte
	local buf6[3]:byte
	local buf7[4]:byte
	
	invoke RtlZeroMemory, addr buf1 , sizeof buf1
	invoke RtlZeroMemory, addr buf2 , sizeof buf2
	invoke RtlZeroMemory, addr buf3 , sizeof buf3
	invoke RtlZeroMemory, addr buf4 , sizeof buf4
	invoke RtlZeroMemory, addr buf5 , sizeof buf5
	invoke RtlZeroMemory, addr buf6 , sizeof buf6
	invoke RtlZeroMemory, addr buf7 , sizeof buf7
	
	mov esi,TimeAddr
	
	add esi,7
	invoke memcpy,addr buf1, esi, 2                                                                              
	invoke atodw,addr buf1
	add eax,2000
	mov @Year,eax
	
	add esi,3
	invoke memcpy,addr buf2, esi, 2 
	invoke atodw,addr buf2
	mov @Mon,eax
	
	add esi,3
	invoke memcpy,addr buf3, esi, 2                                                                            
	invoke atodw,addr buf3
	mov @Dat,eax
	
	add esi,3
	invoke memcpy,addr buf4, esi, 2                                                                            
	invoke atodw,addr buf4
	add eax,hTimeZone
	mov @Hour,eax

	add esi,3
	invoke memcpy,addr buf5, esi, 2                                                                            
	invoke atodw,addr buf5
	mov @Min,eax

	add esi,3
	invoke memcpy,addr buf6, esi, 2                                                                            
	invoke atodw,addr buf6
	mov @Sec,eax

	add esi,10
	invoke memcpy,addr buf7,esi, 3                                                                            
	invoke atodw,addr buf7
	mov @Mss,eax
	
	invoke GetTickCount
	mov t3,eax
	
	sub eax,t2
	mov deltaT2,eax
	mov eax,t2
	sub eax,t1
	mov deltaT1,eax

	mov ebx,deltaT1
	shr ebx,1		; for half deltaT1
	add ebx,deltaT2		; for Milliseconds compensate, half deltaT1 + deltaT2

	mov eax,@Mss
	add eax,ebx
	mov @Mss,eax
	
	.if @Mss >= 1000
		sub @Mss,1000
		inc @Sec
	.endif
	.if @Sec >= 60
		sub @Sec,60
		inc @Min
	.endif
	.if @Min >= 60
		sub @Min,60
		inc @Hour
	.endif
	.if @Hour >= 24
		sub @Hour,24
		inc @Dat
	.endif
	
	.if hTimeZone > 12
		dec @Dat			; west world
		.if @Dat==0
			invoke MessageBox,hWnd,SADD("Plese Synchronizated Time On Next Day."),ADDR szCaption,MB_OK or MB_ICONSTOP
			jmp @exit
		.endif
	.endif
	
	mov bx,word ptr @Year
	mov Stm.wYear,bx
	
	mov bx,word ptr @Mon
	mov Stm.wMonth,bx

	mov bx,word ptr @Dat
	mov Stm.wDay,bx
	
	mov bx,word ptr @Hour
	mov Stm.wHour,bx

	mov bx,word ptr @Min
	mov Stm.wMinute,bx

	mov bx,word ptr @Sec
	mov Stm.wSecond,bx

	mov bx,word ptr @Mss
	mov Stm.wMilliseconds,bx
	
	invoke AdjustToken,SADD("SE_SYSTEMTIME_NAME")
	invoke SetLocalTime,addr Stm
	.if eax==0
		invoke HandleError,ADDR szCaption
	.else
		invoke MessageBox,hWnd,SADD("OK,Synchronizated Your PC Time."),ADDR szCaption,MB_OK or MB_ICONINFORMATION
	.endif
@exit:	invoke ExitThread,NULL
	ret

SetTime ENDP
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov eax,uMsg
	.if eax==WM_INITDIALOG
		m2m hWnd,hWin
		invoke SendDlgItemMessage,hWin,IDC_EDT1,EM_LIMITTEXT,2,0
		invoke LoadIcon,hInstance,500
		mov hIcon,eax
		invoke SendMessage,hWin,WM_SETICON,NULL,hIcon
		invoke SetTimer,hWin,0,1000, 0	
		invoke WSAStartup, 202h, addr wsd
	.elseif eax==WM_TIMER
 		invoke GetLocalTime, offset time
		invoke GetDateFormat, LOCALE_USER_DEFAULT, NULL,offset time,offset dateformat, offset dbuffer, sizeof dbuffer
		invoke GetTimeFormat, LOCALE_USER_DEFAULT,NULL,offset time, offset timeformat, offset sbuffer, sizeof sbuffer

		invoke SendDlgItemMessage,hWin,IDC_EDT2,WM_SETTEXT,0,offset sbuffer
		invoke SendDlgItemMessage,hWin,IDC_EDT3,WM_SETTEXT,0,offset dbuffer
	.elseif eax==WM_COMMAND
		mov eax,wParam
		and eax,0FFFFh
		.if	eax==IDC_BTSync
			invoke RtlZeroMemory, offset Timebuf, sizeof Timebuf
			invoke GetHostAddr
			.if eax==TRUE
				invoke ReadTime
				.if eax==TRUE
					invoke CreateThread,NULL,NULL,addr SetTime,offset Timebuf,\
							IDLE_PRIORITY_CLASS,ADDR ThreadID
					invoke SetThreadPriority,eax,THREAD_PRIORITY_NORMAL				
					invoke CloseHandle,eax
				.endif
			.endif
		.elseif eax==IDC_BTHelp
			invoke MessageBox,hWin,addr AboutMsg,addr szCaption,MB_OK or MB_ICONINFORMATION
		.endif
	.elseif eax==WM_CLOSE
		invoke WSACleanup
		invoke KillTimer,hWin,0 
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret
WndProc endp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG

	mov wc.cbSize,SIZEOF WNDCLASSEX
	mov wc.style,CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc,OFFSET WndProc
	mov wc.cbClsExtra,NULL
	mov wc.cbWndExtra,DLGWINDOWEXTRA
	push hInst
	pop wc.hInstance
	mov wc.hbrBackground,COLOR_BTNFACE+1
	mov wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,500
	mov wc.hIcon,eax
	mov wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,addr DlgName,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
		.BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov eax,msg.wParam
	ret
WinMain endp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
start:
	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke WinMain,hInstance,NULL,eax,SW_SHOWDEFAULT
	invoke ExitProcess,eax
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

end start

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
